#ifndef _DEPTH_MAP_
#define _DEPTH_MAP_

#include "Projector.h"
#include "RangeGrid.h"

// Element stored in the depth buffer
struct DepthElement {
    float z;
    float conf;
};


class DepthMap {
   
  public:

   int xdim;             // width of depth map
   int ydim;             // height of depth map
   DepthElement *elems;  // the depth map

   Projector *proj;
   
   DepthMap();

   // New depth map with specified dimensions
   DepthMap(int,int);
   
   ~DepthMap();

   // Create a range grid from a depth map
   RangeGrid *buildRangeGrid();
};


#endif
