#include <stdio.h>
#include <stdlib.h>
//changed by lizhang
#ifdef LINUX
#include <strings.h>
#endif
#ifdef WIN32
#include <string.h>
#endif
//end of change

#include "RangeGrid.h"
#include "ply.h"
#include "plyio.h"

RangeGrid::RangeGrid()
{
   intensity = NULL;
   confidence = NULL;
   matDiff = NULL;
   hasColor = 0;
   hasIntensity = 0;
   hasConfidence = 0;
   hasNormals = 0;

   viewDir.setValue(0, 0, -1);
}


RangeGrid::~RangeGrid()
{
   delete [] coords;
   
   delete [] indices;
   
   if (num_obj_info > 0) {
      for (int i = 0; i < num_obj_info; i++)
	 delete [] obj_info[i];
      delete [] obj_info;
   }
   
   if (hasConfidence)
      delete [] confidence;
   
   if (hasColor)
      delete [] matDiff;
   
   if (hasIntensity)
      delete [] intensity;
   
   if (hasNormals)
      delete [] norms;
   
}


void
RangeGrid::applyXform(Matrix4f &mat)
{
   Vec3f vec, dir;

   for (int i = 0; i < numSamples; i++) {
      mat.multVec(coords[i], vec);
      coords[i] = vec;

      if (hasNormals) {
	 mat.multDir(norms[i], dir);
	 norms[i] = dir;
      }
   }
}


int
RangeGrid::readPly(char *filename)
{
   return readRangeGridPly(this, filename);
}

int
RangeGrid::writePly(char *filename)
{
   return writeRangeGridPly(this, filename);
}

